<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Reports extends CI_Model {
		
		public function __construct(){
			
	         
			$this->datetime=date("Y-m-d H:i:s");
			$this->table="jobs";
			$this->today=date("Y-m-d");
			//$this->RegistryId=$this->session->userdata('RegistryId');
			//$this->CountyId=$this->session->userdata('CountyId'); 
		  
		   
		}

	  
		


		
public function jobs($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy');
    $this->db->where(array("t.Date >=" => $StartDate, "t.Date <=" => $EndDate));
    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}
		
public function delivereds($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "Delivered" // Filtering by 'Delivered' status
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}
public function dones($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "Complete" // Filtering by 'Delivered' status
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}
public function ongoings($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "On Going" // Filtering by 'Delivered' status
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}

public function artworks($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "Awaiting Artwork" // 
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}

public function awaitingDs($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "Awaiting Delivery" // 
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}

public function reccees($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "Reccee" // 
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}
public function invoices($datefrom, $dateto)
{
    $datefrom = strtotime($datefrom);
    $datefrom = date("Y-m-d", $datefrom);
    $dateto = strtotime($dateto);
    $dateto = date("Y-m-d", $dateto);

    $StartDate = $datefrom . ' 00:00:00';
    $EndDate = $dateto . ' 23:59:59';
    $rows = [];

    $this->db->select('*')
        ->from($this->table . ' t')
        ->join('users u', 'u.id=t.CreatedBy')
        ->where(array(
            "t.Date >=" => $StartDate,
            "t.Date <=" => $EndDate,
            "t.status" => "invoiced" // 
        ));

    $query = $this->db->get();

    if ($query->num_rows() > 0) {
        $rows = $query->result();
    }

    $query->free_result();
    return $rows;
}
	














		
		
		




























		 
		
		
		

}