<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Users extends CI_Model {
		
		public function __construct(){
			
			$this->table="users";
			$this->datetime=date("Y-m-d H:i:s");
		    $this->id=$this->session->userdata('id');
			$this->FirstName=$this->session->userdata('FirstName');
		   
		    
		}



    

		public function creates()
		{
			
			$row = [];
			$this->db->select('*' )
					->from('registrys')->where(array('id'=>$this->input->post("RegistryId")));
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}
				if($row ){
					$CountyId=$row->CountyId;
					$SubCountyId=$row->SubCountyId;
					$WardId=$row->WardId;
				}else{
					return false;
				}
			

			
			$this->db->trans_begin();
			if($this->db->insert( $this->table, [
				
				'DateCreated' => $this->datetime,
				'FirstName' => $this->input->post("FirstName"),
				'OtherName' => $this->input->post("OtherName"),
				'IDNumber' => $this->input->post("IDNumber"),
				'PhoneNumber' => '0'.substr($this->input->post("PhoneNumber"),-9,9 ),
				'EmailAddress' => $this->input->post("EmailAddress"),
				'RoleId'=>$this->input->post("SystemRole"),
				'SystemRole'=>$this->input->post("SystemRole"),
				'RegistryId'=>$this->input->post("RegistryId"),
				'CountyId'=>$CountyId,
				'SubCountyId'=>$SubCountyId,
				'WardId'=>$WardId,
				'DateModified'=>$this->datetime,
				'CreatedBy'=>$this->id, 
				'ModifiedBy'=>$this->id,   
				'Password' => password_hash($this->input->post("PhoneNumber") , PASSWORD_BCRYPT),
			//the user will first use his/her contact to login then, will be directed to the change password, to put a new pass of his choice
				'UserId'=> $this->id
				//print_r( $userrole); exit;
				
			] ))
			
			{
				    $id = $this->db->insert_id();
				  
				   // $data = array( 'feeId' =>$id,);

											$data=array('UserId'=>$id,);
										 $this->db->where('id', $id);
					 			     $this->db->update($this->table,  $data);


			      
			         $this->db->insert('audit', [
						'Description' => $this->first_name ." added user ".  $this->input->post("FirstName") ." ". $this->input->post("LastName"),
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					
			       if ($this->db->trans_status() === FALSE)
	 				{
	       				 $this->db->trans_rollback();
	       			
	       				 return false;
					}
					else
					{
	      				  $this->db->trans_commit();
	      				
	      				
	      				     return true;
					}


				 
				
				}else{
					
					return false;
				}

				
				
		
		}
	

        function to_curl($url, $data)
	     {

	     $headers = array
	        (
	          'Content-Type: application/json',
	          'Content-Length: ' . strlen( json_encode($data) ) 
	        );
	     

	      $ch = curl_init();  
	      curl_setopt($ch, CURLOPT_URL, $url);  
	      curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST" ); 
	      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1 ); 
	      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);  
	       curl_setopt($ch, CURLOPT_HTTPHEADER,  $headers );
	      
	      curl_setopt($ch, CURLOPT_POST, 1); 
	      curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));  
	      $output = curl_exec($ch); 

	        
	      $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	     
	      curl_close($ch); 
	      return $output;
	      
	  }

		public function roles()
		{
			
			$rows = [];
			$this->db->select('*' )
					->from('roles')->where(array('Status'=>1));
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();	
			}
				
			return( $rows );	
				
		}

		public function registrys()
		{
			
			$rows = [];
			$this->db->select('*' )
					->from('registrys')->where(array('Status'=>1));
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();	
			}
				
			return( $rows );	
				
		}

		public function lists()
		{
			
			$rows = [];
			
			$this->db->select('u.*,r.Title as role,s.Title as status' )
					->from($this->table .' u')
		            ->join('roles r','u.SystemRole=r.id')
		            ->join('statuses s', 'u.Status=s.StatusId')
		         //   ->where(array('u.SystemRole <='=>2))
					->order_by('u.UserId','DESC');
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();
				
			}
			if($rows){
				for ($i = 0; $i <count($rows); $i++) :
					 

						$recs = &$rows[$i];
		                $records[$i]['FirstName'] = $recs->FirstName;
		                $records[$i]['OtherName'] = $recs->OtherName;
		                $records[$i]['IDNumber'] = $recs->IDNumber;
		                $records[$i]['EmailAddress'] = $recs->EmailAddress;
		                $records[$i]['SystemRole'] = $recs->SystemRole;
		                $records[$i]['StaffID'] = $recs->StaffID;
		                $records[$i]['role'] = $recs->role;
		 				 $records[$i]['PhoneNumber'] = $recs->PhoneNumber;
		                $records[$i]['status'] = $recs->status;
		                $records[$i]['DateCreated'] = date("d M Y h:i:s A", strtotime($recs->DateCreated));
		                $records[$i]['id'] = $recs->id;
		                $records[$i]['UserId'] = $recs->UserId;
		                if($record=$this->detail_user($recs->id)){
		                	 $records[$i]['CreatedByFirstname'] = $record->FirstName;
		                     $records[$i]['CreatedByOtherName'] = $record->OtherName;
		                }else{
		                	 $records[$i]['CreatedByFirstname'] = "";
		                     $records[$i]['CreatedByOtherName'] = "";
		                }
		               

				endfor;

				if (!empty($records)) {
	                foreach ($records as $record) :

	                    $roc[] = (object)$record;
	                endforeach;
                }
                return( $roc );







			}

			
          
	
			return( $rows );	
				
		}

		public function detail_user($id){
			 
			$row = array();		
			$this->db->select('*');
			$this->db->from( $this->table);	
			$this->db->where('userId',$id);
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();
			
			}		
			return( $row );
		}
		public function edit_users($id)
		{



			$row = [];
			$this->db->select('*' )
					->from('registrys')->where(array('id'=>$this->input->post("RegistryId")));
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}
				if($row ){
					$CountyId=$row->CountyId;
					$SubCountyId=$row->SubCountyId;
					$WardId=$row->WardId;
				}else{
					return false;
				}


		
			
			 $data = array(
				'FirstName' => $this->input->post("FirstName"),
				'OtherName' => $this->input->post("OtherName"),
				'IDNumber' => $this->input->post("IDNumber"),
				'PhoneNumber' => '0'.substr($this->input->post("PhoneNumber"),-9,9 ),
				'EmailAddress' => $this->input->post("EmailAddress"),
				'RoleId'=>$this->input->post("SystemRole"),
				'SystemRole'=>$this->input->post("SystemRole"),
				'RegistryId'=>$this->input->post("RegistryId"),
				'CountyId'=>$CountyId,
				'SubCountyId'=>$SubCountyId,
				'WardId'=>$WardId,
			
				'Status' => $this->input->post("Status") ,
				'DateModified'=>$this->datetime,
				'ModifiedBy'=>$this->id,   
				);
			  $this->db->where('UserId',$id);
			  if($this->db->update($this->table,  $data)){
			  		$this->db->insert('audit', [
			  			'Description' => $this->first_name ." edited user ".  $this->input->post("FirstName") ." ". $this->input->post("LastName"),
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					
					 return true;
			  }else{
				 return false;
			  }	
		}
		public function statuses()
		{
			$rows = [];
			$this->db->select('*' )
					->from('statuses');
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();	
			}		
			return( $rows );	
				
		}


		
	
		public function deletee($id)
		{
			
			 $data = array(
						'DateModified' => $this->datetime,
						'ModifiedBy'=>$this->id, 
						'Status' => 0,	
				);

			  $this->db->where('id',$id);
			  if($this->db->update($this->table,  $data)){
			  	
			  		$this->db->insert('audit', [
			  			'Description' => $this->first_name ." Deactivated User id " . $id ,
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					
					return true;
			  }else{
				 return false;
			  }	
		}

			public function activateds($id)
		{
			
			 $data = array(
						'DateModified' => $this->datetime,
						'ModifiedBy'=>$this->id, 
						'Status' => 1,	
				);

			  $this->db->where('id',$id);
			  if($this->db->update($this->table,  $data)){
			  	
			  		$this->db->insert('audit', [
			  			'Description' => $this->first_name ." activated user id " . $id,
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					
					return true;
			  }else{
				 return false;
			  }	
		}



		public function changepassword(){
		$this->db->where('UserId',$this->session->userdata('id'));
		$data=array(
			'Password' => password_hash( $this->input->post( "newpassword" ), PASSWORD_BCRYPT ),
			'password_set'=>1

			
			);
			if($this->db->update($this->table, $data)):
				return true;
			else:
				return false;
			endif;

		}
		public function get_oldpass(){
			$row=array();
         
			$this->db->select('*');
			$this->db->from($this->table);
			$this->db->where(['UserId'=>$this->session->userdata('id')]);
			$query = $this->db->get();
			$row = $query->row();
      
			if ($query->num_rows()>0){
				$password= $row->Password;
				if(( password_verify( $this->input->post( "password" ), $password ) )){
					return TRUE;
				}else{
					return FALSE;
				}
			}else{
				$query->free_result();
				return FALSE;
			}


		}
		
		public function userroles($id){
			$row = array();		
			$this->db->select('*');
			$this->db->from( "rolesettings");	
			$this->db->where('RoleId',$id);
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}	
		
			return( $row );
		}
		

      
		 public function checkuseremails($email){
		 	
			$row =array();		
			$this->db->select('*');
			$this->db->from( "users");
            $this->db->where(array('Email'=>$email));
            $query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}
		

            //print_r( $row); exit;
				
			return( $row );
		 }
		 public function getrolename($id){
			 
			$row = array();		
			$this->db->select('*');
			$this->db->from('roles');	
			$this->db->where('id',$id);
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();
			
			}	
			if($row){
				return( $row->Title);
			}else{
				$row="-";
				return( $row );
			}
			
		}



/*CREATE  TABLE `admin_tolls`.`users` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `UserId` INT NULL ,
  `FirstName` VARCHAR(45) NOT NULL ,
  `OtherName` VARCHAR(45) NOT NULL ,
  `IDNumber` VARCHAR(45) NOT NULL ,
  `SystemRole` INT NOT NULL ,
  `EmailAddress` VARCHAR(45) NOT NULL ,
  `PhoneNumber` VARCHAR(45) NOT NULL ,
  `StaffID` VARCHAR(45) NULL ,
  `DateCreated` DATETIME NOT NULL ,
  `Password` VARCHAR(200) NOT NULL ,
  `DateModified` DATETIME NOT NULL ,
  `CreatedBy` INT NOT NULL ,
  `ModifiedBy` INT NOT NULL ,
  `Status` INT NOT NULL DEFAULT 1 ,
  PRIMARY KEY (`id`) );*/

/*CREATE  TABLE `admin_tolls`.`statuses` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `Description` VARCHAR(200) NOT NULL ,
  `SourceTable` VARCHAR(45) NOT NULL ,
  `RecordKey`  INT NOT NULL ,
  `UserKey`  INT NOT NULL ,
  `DateCreated` DATETIME NOT NULL ,
  
  PRIMARY KEY (`id`) );
*/

/*CREATE  TABLE `admin_tolls`.`statuses` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `Title` VARCHAR(20) NOT NULL ,
  
  PRIMARY KEY (`id`) );
*/


	
		
		
		
		
}