<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Newjobs extends CI_Model {
		
		public function __construct(){
			
			$this->table="jobs";
			$this->datetime=date("Y-m-d H:i:s");
		    $this->id=1;//$this->session->userdata('id');
		   
		    $this->first_name=$this->session->userdata('first_name');
		   
		   
		}

		public function creates()
		{

		
			
			$this->db->trans_begin();
			if($this->db->insert( $this->table, [
				'Date' => $this->input->post("Date"),
				'ClientName' => $this->input->post("ClientName"),
				'JobDescription' => $this->input->post("JobDescription"),
				'Quantity' => $this->input->post("Quantity"),
				'LPO' => $this->input->post("LPO"),
				'AccountM' => $this->input->post("AccountM"),
				'OperationP' => $this->input->post("OperationP"),
				'InvoiceNo' => $this->input->post("InvoiceNo"),
				'status' => $this->input->post("status"),
				'dateCreated' => $this->datetime,
				'dateModified' => $this->datetime,
                'createdBy' => $this->id,
                'modifiedBy' => $this->id,
                	
			] )){
				  $id = $this->db->insert_id();

				  $data = array(
				    'id' =>$id ,
				   
			     );

			     $this->db->where('id',$id);
			     $this->db->update($this->table,  $data);
                 

				  $this->db->insert('audit', [
						'Description' =>  $this->first_name ." added new job -".  $this->input->post("ClientName") ,
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
				] );

				       
			    if ($this->db->trans_status() === FALSE)
	 			{
	       				 $this->db->trans_rollback();
	       				 return false;
					}
					else
					{
	      				  $this->db->trans_commit();
	      				     return true;
				}
				}else{
					return false;
				}

				
				
				
			
		}

		

		public function lists()
		{
			$rows = [];
			$this->db->select('t.*,u.FirstName,' )
					->from($this->table .' t')
					//->join('incometypes i','i.id=t.incomeTypeId','left')
				  ->join('users u', 't.createdBy=u.UserID')
				  // ->join('statuses s', 't.Status=s.StatusId')->group_by('t.id')
				   ->order_by('t.id','DESC') ;
			//$this->db->where( array('t.Status'=>1),'AND');
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();	
			}
			return( $rows );
		}

		public function deletejob($id){
			$this->db->delete('jobs',['id' =>$id]);
			
	
			}
	

		// public function lists()
		// {
		// 	 $this->db->select('feesandcharges.*,incometypes.incomeTypeDescription');
  //  			 $this->db->from('feesandcharges');
  //   		$this->db->join('incometypes','incometypes.id=feesandcharges.incomeTypeId', 'left');
  //   		$query=$this->db->get();
  //  			 return $query->result();
    
				
		// }


		
		public function details($id){
			$row = array();		
			$this->db->select('*');
			$this->db->from( $this->table);	
            $this->db->where('id',$id);
            $query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}
			
			return( $row );
		}
		
		
		
		
		public function deletee($id)
		{
			$data = array(
				'DateModified' => $this->datetime,
				'status' => 0 ,	
				'DateCreated' => $this->id,
			);

			$this->db->where('id',$id);
			if($this->db->update($this->table,  $data)){
				
					$this->db->insert('audit', [
						'Description' => $this->first_name ." deactivated  job ",
						'SourceTable' =>$this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					return true;
			}else{
				return false;
			}	
		}
		public function activateds($id)
		{
			$data = array(
				'DateModified' => $this->datetime,
				'status' => 1 ,	
				'DateCreated' => $this->id,
			);

			$this->db->where('id',$id);
			if($this->db->update($this->table,  $data)){
				
					$this->db->insert('audit', [
						'Description' => $this->first_name ." activated job ",
						'SourceTable' =>$this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					return true;
			}else{
				return false;
			}	
		}
		
		// public function edits($id)
		// {
			
			 
		// 	 $data = array(
		// 	 	'incomeTypeId' => $this->input->post("incomeTypeId"),
		// 		'feeDescription' => $this->input->post("feeDescription"),
		// 		'typeDescription' => $this->input->post("typeDescription"),
		// 		'unitFeeAmount' => $this->input->post("unitFeeAmount"),
		// 		'dateModified' => $this->datetime,
  //               'modifiedBy' => $this->id,



                
		// 	  );

		// 	  $this->db->where('feeId',$id);
			  
		// 	  if($this->db->update($this->table,  $data)){
		// 	  		$this->db->insert('audit', [
		// 	  			'Description' =>  $this->first_name ." updated feesandcharges ",
		// 				'SourceTable' => $this->table,
		// 				'RecordKey'=> $id,
		// 				'UserKey'=>  $this->id
						
		// 			] );
		// 			 return true;
		// 	  }else{
		// 		 return false;
		// 	  }	
		// }

		public function edit_Newjobs($id)
		{


			$row = [];
			$this->db->select('*' )
					->from('jobs')->where(array('id'=>$this->input->post("id")));
			$query = $this->db->get();
			if($query->result()){
				$row = $query->row();	
				$query->free_result();	
			}
				
			
			 $data = array(
				'Date' => $this->input->post("Date"),
				'ClientName' => $this->input->post("ClientName"),
				'JobDescription' => $this->input->post("JobDescription"),
				'Quantity' => $this->input->post("Quantity"),
				'LPO' => $this->input->post("LPO"),
				'AccountM' => $this->input->post("AccountM"),
				'OperationP' => $this->input->post("OperationP"),
				'InvoiceNo' => $this->input->post("InvoiceNo"),
				'BriefNo' => $this->input->post("BriefNo"),
	 		    'dateModified' => $this->datetime,
                'modifiedBy' => $this->id,
				'status' => $this->input->post("status"),  
				);
			 
			  $this->db->where('id',$id);
			  if($this->db->update($this->table,  $data)){
			  		$this->db->insert('audit', [
			  			'Description' => $this->first_name ." edited user ".  $this->input->post("FirstName") ." ". $this->input->post("LastName"),
						'SourceTable' => $this->table,
						'RecordKey'=> $id,
						'UserKey'=>  $this->id
						
					] );
					
					 return true;
			  }else{
				 return false;
			  }

		}
public function incometypes()
		{
			
			$rows = [];
			$this->db->select('*' )
					->from('incometypes')->where(array('Status'=>1));
			$query = $this->db->get();
			if($query->result()){
				$rows = $query->result();	
				$query->free_result();	
			}
				
			return( $rows );	
				
		}



		public function edits($id)
		{
			 		
			 
			 $data = array(
				// 'Descriptions' => $this->input->post("Descriptions"),
				// 'DateModified' => $this->datetime,
                // 'SystemUser' => $this->first_name,
                //  'UserID' => $this->id,
				'Date' => $this->input->post("Date"),
				'ClientName' => $this->input->post("ClientName"),
				'JobDescription' => $this->input->post("JobDescription"),
				'Quantity' => $this->input->post("Quantity"),
				'LPO' => $this->input->post("LPO"),
				'AccountM' => $this->input->post("AccountM"),
				'OperationP' => $this->input->post("OperationP"),
				'BriefNo' => $this->input->post("BriefNo"),
				'InvoiceNo' => $this->input->post("InvoiceNo"),
				'status' => $this->input->post("status"),
				'dateCreated' => $this->datetime,
				'dateModified' => $this->datetime,
                'createdBy' => $this->id,
                'modifiedBy' => $this->id,
				
			  );

			  $this->db->where('id',$id);
			  
			  if($this->db->update($this->table,  $data)){
			  		$this->db->insert('audit', [
			  			'Description' => "Updated role",
						  'SourceTable' => $this->table,
						  'RecordKey'=> $id,
						  'UserKey'=>  $this->id
						
					] );
					 return true;
			  }else{
				 return false;
			  }	
		}

	 
}